#!/usr/bin/env python
# -*- coding: utf-8 -*-
# coding=utf-8
from __future__ import print_function
import matplotlib.pyplot as plt
import matplotlib.image as mpimg # For loading of png's
from matplotlib.widgets import Cursor
import matplotlib
from matplotlib.lines import Line2D
from matplotlib.widgets import AxesWidget
import sys
import numpy as np
import savecsel as vs # My vector selectors (and in future roi management)
from sapiawin import *
from sapatt import *

#------------------------------------------------------------------------------------

def banner():
    # print the name of the running script
    myname = os.path.basename(sys.argv[0])
    self.poutput("Finished: {!r}".format(myname))
    pass
#END banner()

def argexpand( specs ):
    '''Expand the argument list, if the user has given less than specs
    arguments'''
    result = sys.argv[1:]
    while len( result ) < specs:
        result.append( '' )
    return result
#END argexpand()

def doit():
    '''doit does the work'''
    #argument lister
    #for i, arg in enumerate(sys.argv[1:]):
    #    print("arg {}: {!r}".format(i+1, arg))

    ### Argument parsing
    argus = len( sys.argv ) - 1 # Number of provided arguments

    arglist = argexpand( 3 ) # expand to 3 arguments

    #pia = piawins( self.piawinds, verbose=True )
    self.pia = piawins( self.piawinds )
    # pia = piawins() # with internal windict

    imgfile = sys.argv[1]
    if argus < 2:
        ulevel = None
    else:
        ulevel = float(sys.argv[2])

    found = imgfile
    if not os.path.isfile(found):
        found = found + '.sjs' # simple JSON format

    if os.path.isfile(found):
        b = Patt()
        b.load( found )
        mytitle = imgfile

        # Special transformations
        b.rot90() # rotate pattern
        mytitle = mytitle + '_lin'

        self.patt = b # Make the last one available for ipython
        # b.hasa() # Dump all attributes
        # b.mapp[b.mapp<0.0]=0.0 # set all negative values to 0
        #b.mapp[b.mapp>0.0]=1.0 # and all positive ones to 1 (a mask)
        b.showi(self.pia, wintit=mytitle, ulev=ulevel, logscale=False, clut='CMRmap')
    else:
        print('File "%s" does not exist'%imgfile)

    """
    imgover = sys.argv[2]
    img = mpimg.imread(imgover)
    pia.popup( img, winnum=3,wintit='Completely replaced' )
    """
    """
    imgfresh = sys.argv[1]
    img = mpimg.imread(imgfresh)
    pia._freshup( img, winnum=2,wintit='Fresh content' )
    """
#END doit()

# END script procedures

# Main:
# Make the window dictionary, if it does not exist
try:
    self.piawinds
except:
    self.piawinds = {}
err = doit()
if err:
    self.poutput( err )
    # No signaling of error to the caller
banner()
