#!/usr/bin/env python
# -*- coding: utf-8 -*-
# coding=utf-8
from __future__ import print_function
import matplotlib.pyplot as plt
import matplotlib.image as mpimg # For loading of png's
from matplotlib.widgets import Cursor
import matplotlib
from matplotlib.lines import Line2D
from matplotlib.widgets import AxesWidget
import sys
import numpy as np
import savecsel as vs # My vector selectors (and in future roi management)
from sapiawin import *
from sapatt import *

#------------------------------------------------------------------------------------

''' This is nothing but a presenter (for raw data). The median smoothing
    helps to find a good scaling automatically.
'''

def banner():
    # print the name of the running script
    myname = os.path.basename(sys.argv[0])
    self.poutput("Finished: {!r}".format(myname))
    pass
#END banner()

def argexpand( specs ):
    '''Expand the argument list, if the user has given less than specs
    arguments'''
    result = sys.argv[1:]
    while len( result ) < specs:
        result.append( '' )
    return result
#END argexpand()

def doit():
    '''doit does the work'''

    ### Argument parsing
    argus = len( sys.argv ) - 1 # Number of provided arguments

    arglist = argexpand( 3 ) # expand to 3 arguments

    #pia = piawins( self.piawinds, verbose=True )
    if not hasattr(self,'pia'):
        self.pia = piawins( self.piawinds )
    # self.pia = piawins() # with internal windict

    imgfile = sys.argv[1]
    if argus < 2:
        ulevel = None
    else:
        ulevel = float(sys.argv[2])

    found = imgfile
    if not os.path.isfile(found):
        found = found + '.sjs' # simple JSON format

    if os.path.isfile(found):
        b = Patt()
        b.load( found )
        # remove spikes from cosmic rays generously
        b.median(5)
         
        b.hasa() # Dump all attributes
        b.showi(self.pia, wintit=imgfile, ulev=ulevel, clut='CMRmap')
    else:
        print('File "%s" does not exist'%imgfile)

# END doit()

# END script procedures

# Main:
# Make the window dictionary, if it does not exist
try:
    self.piawinds
except:
    self.piawinds = {}
err = doit()
if err:
    self.poutput( err )
    # No signaling of error to the caller
banner()
